//#line 2 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the theora_image_transport package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __theora_image_transport__THEORAPUBLISHERCONFIG_H__
#define __theora_image_transport__THEORAPUBLISHERCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace theora_image_transport
{
  class TheoraPublisherConfigStatics;
  
  class TheoraPublisherConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(TheoraPublisherConfig &config, const TheoraPublisherConfig &max, const TheoraPublisherConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const TheoraPublisherConfig &config1, const TheoraPublisherConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, TheoraPublisherConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const TheoraPublisherConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, TheoraPublisherConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const TheoraPublisherConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T TheoraPublisherConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (TheoraPublisherConfig::* field);

      virtual void clamp(TheoraPublisherConfig &config, const TheoraPublisherConfig &max, const TheoraPublisherConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const TheoraPublisherConfig &config1, const TheoraPublisherConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, TheoraPublisherConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const TheoraPublisherConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, TheoraPublisherConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const TheoraPublisherConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 14 "../cfg/TheoraPublisher.cfg"
      int optimize_for;
//#line 15 "../cfg/TheoraPublisher.cfg"
      int target_bitrate;
//#line 16 "../cfg/TheoraPublisher.cfg"
      int quality;
//#line 17 "../cfg/TheoraPublisher.cfg"
      int keyframe_frequency;
//#line 138 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("TheoraPublisherConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const TheoraPublisherConfig &__max__ = __getMax__();
      const TheoraPublisherConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const TheoraPublisherConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const TheoraPublisherConfig &__getDefault__();
    static const TheoraPublisherConfig &__getMax__();
    static const TheoraPublisherConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const TheoraPublisherConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void TheoraPublisherConfig::ParamDescription<std::string>::clamp(TheoraPublisherConfig &config, const TheoraPublisherConfig &max, const TheoraPublisherConfig &min) const
  {
    return;
  }

  class TheoraPublisherConfigStatics
  {
    friend class TheoraPublisherConfig;
    
    TheoraPublisherConfigStatics()
    {
//#line 14 "../cfg/TheoraPublisher.cfg"
      __min__.optimize_for = 0;
//#line 14 "../cfg/TheoraPublisher.cfg"
      __max__.optimize_for = 1;
//#line 14 "../cfg/TheoraPublisher.cfg"
      __default__.optimize_for = 1;
//#line 14 "../cfg/TheoraPublisher.cfg"
      __param_descriptions__.push_back(TheoraPublisherConfig::AbstractParamDescriptionConstPtr(new TheoraPublisherConfig::ParamDescription<int>("optimize_for", "int", 0, "Try to achieve either 'target_bitrate' or 'quality'", "{'enum_description': 'Enum to control whether optimizing for bitrate or quality', 'enum': [{'srcline': 10, 'description': 'Aim for requested bitrate', 'srcfile': '../cfg/TheoraPublisher.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'Bitrate'}, {'srcline': 11, 'description': 'Aim for requested quality', 'srcfile': '../cfg/TheoraPublisher.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Quality'}]}", &TheoraPublisherConfig::optimize_for)));
//#line 15 "../cfg/TheoraPublisher.cfg"
      __min__.target_bitrate = 0;
//#line 15 "../cfg/TheoraPublisher.cfg"
      __max__.target_bitrate = 99200000;
//#line 15 "../cfg/TheoraPublisher.cfg"
      __default__.target_bitrate = 800000;
//#line 15 "../cfg/TheoraPublisher.cfg"
      __param_descriptions__.push_back(TheoraPublisherConfig::AbstractParamDescriptionConstPtr(new TheoraPublisherConfig::ParamDescription<int>("target_bitrate", "int", 0, "Target encoding bitrate, bits per second", "", &TheoraPublisherConfig::target_bitrate)));
//#line 16 "../cfg/TheoraPublisher.cfg"
      __min__.quality = 0;
//#line 16 "../cfg/TheoraPublisher.cfg"
      __max__.quality = 63;
//#line 16 "../cfg/TheoraPublisher.cfg"
      __default__.quality = 31;
//#line 16 "../cfg/TheoraPublisher.cfg"
      __param_descriptions__.push_back(TheoraPublisherConfig::AbstractParamDescriptionConstPtr(new TheoraPublisherConfig::ParamDescription<int>("quality", "int", 0, "Encoding quality", "", &TheoraPublisherConfig::quality)));
//#line 17 "../cfg/TheoraPublisher.cfg"
      __min__.keyframe_frequency = 1;
//#line 17 "../cfg/TheoraPublisher.cfg"
      __max__.keyframe_frequency = 64;
//#line 17 "../cfg/TheoraPublisher.cfg"
      __default__.keyframe_frequency = 64;
//#line 17 "../cfg/TheoraPublisher.cfg"
      __param_descriptions__.push_back(TheoraPublisherConfig::AbstractParamDescriptionConstPtr(new TheoraPublisherConfig::ParamDescription<int>("keyframe_frequency", "int", 0, "Maximum distance between key frames", "", &TheoraPublisherConfig::keyframe_frequency)));
//#line 239 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<TheoraPublisherConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<TheoraPublisherConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    TheoraPublisherConfig __max__;
    TheoraPublisherConfig __min__;
    TheoraPublisherConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const TheoraPublisherConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static TheoraPublisherConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &TheoraPublisherConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const TheoraPublisherConfig &TheoraPublisherConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const TheoraPublisherConfig &TheoraPublisherConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const TheoraPublisherConfig &TheoraPublisherConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<TheoraPublisherConfig::AbstractParamDescriptionConstPtr> &TheoraPublisherConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const TheoraPublisherConfigStatics *TheoraPublisherConfig::__get_statics__()
  {
    const static TheoraPublisherConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = TheoraPublisherConfigStatics::get_instance();
    
    return statics;
  }

//#line 10 "../cfg/TheoraPublisher.cfg"
      const int TheoraPublisher_Bitrate = 0;
//#line 11 "../cfg/TheoraPublisher.cfg"
      const int TheoraPublisher_Quality = 1;
}

#endif // __THEORAPUBLISHERRECONFIGURATOR_H__
